#!/usr/bin/env python3
""" Data Structures and Algorithms for CL 3, Assignment 2
    See <https://https://dsacl3-2023.github.io/a3/> for detailed
    instructions.

    <Please insert your name and the honor code here.>
"""

class BinaryTree:
    """A class implementing a binary tree using an array (list) as storage.
    """
    __slots__ = ("T") # The list to use for storing the tree
                      # this prevents other instance variables
                      # Please do not rename (tests rely on the variablre name)
    def __init__(self, rootlabel):
        self.T = [rootlabel] 

    def add_node(self, label, parent=None, child='left'):
        """Add a child node with label to the tree.

        Given the array-based tree representation, add a child node at the
        given 'parent' with the 'label'. If there is already a node in
        this position, the label should be replaced. If necessary, the
        tree should be extended to the minimum size required by the
        current nodes. All changes should be done in-place.

        Parameters
        ----------
        tree        The tree to modify.
        label       The label of the new node.
        parent      The parent of the new node. If parent is 'None' add or
                    modify the root node.
        child       Either 'left' or 'right' indicating whether the (new)
                    child is the left or right child of the 'parent'.

        Returns the index of the (new) child node.

        """
        # Exercise part 1
        pass

    def find_node(self, label, node=0):
        """Return an iterable over the nodes of the tree that matches the 'label'.

        This function should return an iterable (a sequence or a
        generator) that allows looping over all nodes with the same
        label.  For example, find_node("NP") should allow looping over
        indices of all nodes in the tree with label "NP".

        This is essentialy any tree traversal, looking for only a
        particular label.

        The order depends on the tree structure. A match at the left child
        of a node and its descendants should be listed before the node
        itself (if the node also matches), but a match at right child and
        its descendants should be listed after the node.

        You are recommended to try a generator (with yield expression(s)),
        but returning a sequence (e.g., a list) is also fine.

        You can change the function definition by adding additional
        optional arguments if needed.

        Parameters
        ----------
        tree        The tree to modify.
        label       The label to be matched.
        node        Index of the root node (a non-zero number should
                    search only a subtree).

        Returns an iterator over all matching nodes.

        """
        # Exercise part 2
        pass

    def get_height(self, node=0):
        """Return the height of a node, or height of the tree.

        Calculate the height of the given node, the number of edges between
        the node and its lowest descendant.

        Parameters
        ----------
        tree        The tree to modify.
        node        The index of the node whose height to be calculated.

        Returns the height of the node.
        
        """
        # Exercise part 3
        pass

    def get_depth(self, node):
        """Return the depth of a node.

        Calculate the depth of the given node, the number of edges between
        the node and the root node.

        Note that you can use a general solution (that works for all
        any binary tree implemented this way).

        Parameters
        ----------
        tree        The tree to modify.
        node        The index of the node whose height to be calculated.

        Returns the height of the node.
        
        """
        # Exercise part 4
        pass

    def __str__(self):
        """Return a bracketed string representation for the tree.

        The representation should be in 'Penn Treebank' format.
        See the assignment description for examples and explanation.
        Note that this is yet another tree traversal. However, not all
        traversals will produce the desired result.

        Returns the string representation.
        """
        # Exercise part 4
        pass

if __name__ == "__main__":
    pass
